vpp_device: disable IPv6 in containers
[csit.git] / resources / libraries / bash / function / common.sh
index d34035a..a144b3c 100644 (file)
@@ -42,7 +42,6 @@ function activate_docker_topology () {
     source "${BASH_FUNCTION_DIR}/device.sh" || {
         die "Source failed!"
     }
-
     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
     case_text="${NODENESS}_${FLAVOR}"
     case "${case_text}" in
@@ -50,8 +49,9 @@ function activate_docker_topology () {
             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
             # script's functions. Env variables are read from ssh output
             # back to localhost for further processing.
-            hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
-            ssh="ssh root@${hostname} -p 6022"
+            # Shim and Jenkins executor are in the same network on the same host
+            # Connect to docker's default gateway IP and shim's exposed port
+            ssh="ssh root@172.17.0.1 -p 6022"
             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
             # The "declare -f" output is long and boring.
             set +x
@@ -145,7 +145,7 @@ function archive_tests () {
 
     set -exuo pipefail
 
-    tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
+    tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
         die "Error creating archive of generated tests."
     }
 }
@@ -333,8 +333,7 @@ function deactivate_docker_topology () {
     case_text="${NODENESS}_${FLAVOR}"
     case "${case_text}" in
         "1n_skx" | "1n_tx2")
-            hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
-            ssh="ssh root@${hostname} -p 6022"
+            ssh="ssh root@172.17.0.1 -p 6022"
             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
             # The "declare -f" output is long and boring.
             set +x
@@ -461,6 +460,10 @@ function get_test_code () {
             NODENESS="2n"
             FLAVOR="skx"
             ;;
+        *"2n-zn2"*)
+            NODENESS="2n"
+            FLAVOR="zn2"
+            ;;
         *"3n-skx"*)
             NODENESS="3n"
             FLAVOR="skx"
@@ -524,6 +527,19 @@ function get_test_tag_string () {
         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
         # On parsing error, TEST_TAG_STRING probably stays empty.
         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}") || true
+        if [[ -n "${TEST_TAG_STRING-}" ]]; then
+            test_tag_array=(${TEST_TAG_STRING})
+            if [[ "${test_tag_array[0]}" == "icl" ]]; then
+                export GRAPH_NODE_VARIANT="icl"
+                TEST_TAG_STRING="${test_tag_array[@]:1}" || true
+            elif [[ "${test_tag_array[0]}" == "skx" ]]; then
+                export GRAPH_NODE_VARIANT="skx"
+                TEST_TAG_STRING="${test_tag_array[@]:1}" || true
+            elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
+                export GRAPH_NODE_VARIANT="hsw"
+                TEST_TAG_STRING="${test_tag_array[@]:1}" || true
+            fi
+        fi
     fi
 }
 
@@ -710,6 +726,7 @@ function select_tags () {
     # Variables read:
     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
     # - TEST_CODE - String affecting test selection, usually jenkins job name.
+    # - DUT - CSIT test/ subdirectory, set while processing tags.
     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
     #   Can be unset.
     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
@@ -743,7 +760,7 @@ function select_tags () {
         *"3n-tsh"*)
             default_nic="nic_intel-x520-da2"
             ;;
-        *"3n-skx"* | *"2n-skx"* | *"2n-clx"*)
+        *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
             default_nic="nic_intel-xxv710"
             ;;
         *"3n-hsw"* | *"mrr-daily-master")
@@ -769,23 +786,34 @@ function select_tags () {
         # Select specific performance tests based on jenkins job type variable.
         *"ndrpdr-weekly"* )
             readarray -t test_tag_array <<< $(sed 's/ //g' \
-                ${tfd}/mlr-weekly-${NODENESS}-${FLAVOR}.md |
-                eval ${sed_nics_sub_cmd}) || die
+                ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
+                eval ${sed_nics_sub_cmd} || echo "perftest") || die
             ;;
         *"mrr-daily"* )
             readarray -t test_tag_array <<< $(sed 's/ //g' \
-                ${tfd}/mrr-daily-${NODENESS}-${FLAVOR}.md |
-                eval ${sed_nics_sub_cmd}) || die
+                ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
+                eval ${sed_nics_sub_cmd} || echo "perftest") || die
             ;;
         *"mrr-weekly"* )
             readarray -t test_tag_array <<< $(sed 's/ //g' \
-                ${tfd}/mrr-weekly-${NODENESS}-${FLAVOR}.md |
-                eval ${sed_nics_sub_cmd}) || die
+                ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
+                eval ${sed_nics_sub_cmd} || echo "perftest") || die
             ;;
         *"report-iterative"* )
+            test_sets=(${TEST_TAG_STRING//:/ })
+            # Run only one test set per run
+            report_file=${test_sets[0]}.md
+            readarray -t test_tag_array <<< $(sed 's/ //g' \
+                ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
+                eval ${sed_nics_sub_cmd} || echo "perftest") || die
+            ;;
+        *"report-coverage"* )
+            test_sets=(${TEST_TAG_STRING//:/ })
+            # Run only one test set per run
+            report_file=${test_sets[0]}.md
             readarray -t test_tag_array <<< $(sed 's/ //g' \
-                ${tfd}/report-iter-${NODENESS}-${FLAVOR}.md |
-                eval ${sed_nics_sub_cmd}) || die
+                ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
+                eval ${sed_nics_sub_cmd} || echo "perftest") || die
             ;;
         * )
             if [[ -z "${TEST_TAG_STRING-}" ]]; then
@@ -810,7 +838,7 @@ function select_tags () {
     # TODO: Add missing reasons here (if general) or where used (if specific).
     case "${TEST_CODE}" in
         *"2n-skx"*)
-            test_tag_array+=("!ipsechw")
+            test_tag_array+=("!ipsec")
             ;;
         *"3n-skx"*)
             test_tag_array+=("!ipsechw")
@@ -818,7 +846,10 @@ function select_tags () {
             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
             ;;
         *"2n-clx"*)
-            test_tag_array+=("!ipsechw")
+            test_tag_array+=("!ipsec")
+            ;;
+        *"2n-zn2"*)
+            test_tag_array+=("!ipsec")
             ;;
         *"2n-dnv"*)
             test_tag_array+=("!ipsechw")
@@ -841,10 +872,6 @@ function select_tags () {
             test_tag_array+=("!ipsechw")
             ;;
         *"3n-hsw"*)
-            # TODO: Introduce NOIOMMU version of AVF tests.
-            # TODO: Make (both) AVF tests work on Haswell,
-            # or document why (some of) it is not possible.
-            # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
             test_tag_array+=("!drv_avf")
             # All cards have access to QAT. But only one card (xl710)
             # resides in same NUMA as QAT. Other cards must go over QPI
@@ -886,6 +913,13 @@ function select_tags () {
             warn "The following tag expression hints at bad trigger: ${tag}"
             warn "Possible cause: Multiple triggers in a single comment."
             die "Aborting to avoid triggering too many tests."
+        elif [[ "${tag}" == *"OR"* ]]; then
+            # If OR had higher precedence than AND, it would be useful here.
+            # Some people think it does, thus triggering way too much tests.
+            set -x
+            warn "The following tag expression hints at bad trigger: ${tag}"
+            warn "Operator OR has lower precedence than AND. Use space instead."
+            die "Aborting to avoid triggering too many tests."
         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
             # Empty and comment lines are skipped.
             # Other lines are normal tags, they are to be prefixed.
@@ -927,6 +961,10 @@ function select_topology () {
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
             TOPOLOGIES_TAGS="2_node_*_link_topo"
             ;;
+        "2n_zn2")
+            TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
+            TOPOLOGIES_TAGS="2_node_*_link_topo"
+            ;;
         "3n_skx")
             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
             TOPOLOGIES_TAGS="3_node_*_link_topo"